/******************************************************************************** 
Desarrollado por:   Globant de México
Autor:              Roberto Carlos Avendaño Quintana
Proyecto:           TOYOTA TAM
Descripción:        Clase que contiene la logica para el funcionamiento de lookUpController
*************************************************************************/
public without sharing  class lookUpController {
    
    @AuraEnabled
    public static List <wrapVIN > agregarVINEdoCta(String searchKeyWord,String userId, Boolean isAutoDemo, List<wrapperEstadoCta> listaVINES,String tipoEdoCta) {
        User[] usr; 
        List<wrapVIN> wrapListVIN = new List<wrapVIN>();
        List<String> reglasNoCumplidasBonoRetail = new List<String>();
        List <TAM_DetalleEstadoCuenta__c> lstOfVinEdoCta = new List <TAM_DetalleEstadoCuenta__c>();
        List <Movimiento__C > lstOfVinMovimiento = new List <Movimiento__C > ();
        String searchKey = searchKeyWord + '%';
        Set<String> listaVINESet = new Set<String>();
        
        //RecordTypes del objeto detalle estado de cuenta
        String recordTypeIdRetail = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('Retail').getRecordTypeId();
        String recordTypeIdBono = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('Bono').getRecordTypeId();
        String recordTypeIdVC = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('Flotilla').getRecordTypeId();
        
        if(userId != null){
            usr = [Select id,CodigoDistribuidor__c FROM User where id =:userId];   
        }
        
        if(!listaVINES.isEmpty()){
            for(wrapperEstadoCta i : listaVINES){
                listaVINESet.add(i.VIN);
                
            }
            
        }
        
        //Se consultan los VINES pagados en un estado de cuenta (Retail,Bono)
        if(tipoEdoCta == 'Retail' || tipoEdoCta == 'Bono' || tipoEdoCta == 'AutoDemo'){
            lstOfVinEdoCta = [Select id,TAM_Fecha_Pago__c,TAM_FolioFactura__c,TAM_DetalleProvision__r.TAM_PorcentParticipacionTMEX__c,TAM_DetalleProvision__r.TAM_DescuentoAutorizadoDTM__c,TAM_DetalleProvision__r.TAM_IncentivoTMEX_Efectivo__c,TAM_pagoPorTFS__c,TAM_DetalleProvision__r.TAM_TipoProgramaRango__c,TAM_IncentivoPropuestoDealer__c,TAM_VIN__c,TAM_DetalleProvision__r.TAM_AnioModelo__c,TAM_DetalleProvision__r.TAM_CodigoDealer__c,
                              TAM_DetalleProvision__r.TAM_NombreDealer__c,TAM_EstadoCuenta__c,TAM_DetalleProvision__r.TAM_Serie__c,TAM_DetalleProvision__r.TAM_Modelo__c,
                              TAM_Serie__c,TAM_Modelo__c,TAM_AnioModelo__c,TAM_CodigoDealer__c,TAM_NombreDealer__c
                              From TAM_DetalleEstadoCuenta__c WHERE  TAM_VIN__c LIKE: searchKey AND TAM_Estatus_Finanzas__c = 'Pago Autorizado TMEX' AND
                              TAM_VIN__C NOT IN : listaVINESet order by createdDate asc limit 1 ];
            
        }
        //Si corresponde a venta corporativa
        if(tipoEdoCta == 'VentaCorporativa'){
            
            lstOfVinEdoCta = [Select id,TAM_Fecha_Pago__c,TAM_FolioFactura__c,TAM_DetalleProvision__r.TAM_PorcentParticipacionTMEX__c,TAM_DetalleProvision__r.TAM_DescuentoAutorizadoDTM__c,TAM_DetalleProvision__r.TAM_IncentivoTMEX_Efectivo__c,TAM_pagoPorTFS__c,TAM_DetalleProvision__r.TAM_TipoProgramaRango__c,TAM_IncentivoPropuestoDealer__c,TAM_VIN__c,TAM_DetalleProvision__r.TAM_AnioModelo__c,TAM_DetalleProvision__r.TAM_CodigoDealer__c,
                              TAM_DetalleProvision__r.TAM_NombreDealer__c,TAM_EstadoCuenta__c,TAM_DetalleProvision__r.TAM_Serie__c,TAM_DetalleProvision__r.TAM_Modelo__c,
                              TAM_Serie__c,TAM_Modelo__c,TAM_AnioModelo__c,TAM_CodigoDealer__c,TAM_NombreDealer__c
                              From TAM_DetalleEstadoCuenta__c WHERE  TAM_VIN__c LIKE: searchKey AND TAM_Estatus_Finanzas__c = 'Pago Autorizado TMEX' AND TAM_VIN__C NOT IN : listaVINESet order by createdDate asc limit 1];
            
        }
        
        
        if(!lstOfVinEdoCta.isEmpty()){
            for (TAM_DetalleEstadoCuenta__c  VINPagado : lstOfVinEdoCta) {	
                wrapVIN newVIN = new wrapVIN();
                newVIN.Id = VINPagado.Id;
                newVIN.VIN = VINPagado.TAM_VIN__c;
                newVIN.incentivoPagado =VINPagado.TAM_IncentivoPropuestoDealer__c;
                newVIN.ubicacionVIN = 'edoCta';
                //Serie
                if(VINPagado.TAM_DetalleProvision__r.TAM_Serie__c != null && vinPagado.TAM_Serie__c == null){
                    newVIN.Serie = VINPagado.TAM_DetalleProvision__r.TAM_Serie__c ;
                }
                if(VINPagado.TAM_DetalleProvision__r.TAM_Serie__c == null && vinPagado.TAM_Serie__c != null){
                    newVIN.Serie = VINPagado.TAM_Serie__c ;
                }
                //codigo Modelo
                if(VINPagado.TAM_DetalleProvision__r.TAM_Modelo__c != null && vinPagado.TAM_Modelo__c == null){
                    newVIN.codigoModelo = VINPagado.TAM_DetalleProvision__r.TAM_Modelo__c ;
                }
                if(VINPagado.TAM_DetalleProvision__r.TAM_Modelo__c == null && vinPagado.TAM_Modelo__c != null){
                    newVIN.codigoModelo = VINPagado.TAM_Modelo__c ;
                }
                //Anio Modelo
                if(VINPagado.TAM_DetalleProvision__r.TAM_AnioModelo__c != null && vinPagado.TAM_AnioModelo__c == null){
                    newVIN.anioModelo = VINPagado.TAM_DetalleProvision__r.TAM_AnioModelo__c ;
                }
                if(VINPagado.TAM_DetalleProvision__r.TAM_AnioModelo__c == null && vinPagado.TAM_AnioModelo__c != null){
                    newVIN.anioModelo = VINPagado.TAM_AnioModelo__c ;
                }
                //Código Dealer
                if(VINPagado.TAM_DetalleProvision__r.TAM_CodigoDealer__c != null && vinPagado.TAM_CodigoDealer__c == null){
                    newVIN.codigoDealer = VINPagado.TAM_DetalleProvision__r.TAM_CodigoDealer__c ;
                }
                if(VINPagado.TAM_DetalleProvision__r.TAM_CodigoDealer__c == null && vinPagado.TAM_CodigoDealer__c != null){
                    newVIN.codigoDealer = VINPagado.TAM_CodigoDealer__c ;
                }
                //Código dealer 
                if(VINPagado.TAM_DetalleProvision__r.TAM_CodigoDealer__c != null && vinPagado.TAM_CodigoDealer__c != null){
                    newVIN.codigoDealer = VINPagado.TAM_CodigoDealer__c ;
                }
                //Folio de Factura de pago
                if(VINPagado.TAM_FolioFactura__c != null){
                    newVIN.folioFactura = VINPagado.TAM_FolioFactura__c;
                }
                //Fecha de pago de factura
                if(VINPagado.TAM_Fecha_Pago__c != null){
                    newVIN.fechaFactura = VINPagado.TAM_Fecha_Pago__c;
                }
                
                wrapListVIN.add(newVIN);   
                
            }
            
            
        }
        
        if(!wrapListVIN.isEmpty()){
            return wrapListVIN; 
        }else{
            wrapListVIN = lookUpController.validarReglasVINEdoCta(searchKeyWord,userId,listaVINES,tipoEdoCta);
            return wrapListVIN;
        }
        
        
    }
    
    
    @AuraEnabled
    public static List <wrapVIN > validarReglasVINEdoCta(String searchKeyWord,String userId,List<wrapperEstadoCta> listaVINES,String tipoEdoCta) {    
        List<String> reglasNoCumplidasBonoRetail = new List<String>();
        List<wrapVIN> wrapListVIN = new List<wrapVIN>();
        List <Movimiento__C > returnList = new List <Movimiento__C > ();
        List <Movimiento__C > lstOfVin = new List <Movimiento__C > ();
        List <Movimiento__C > lstOfVinVC = new List <Movimiento__C > ();
        TAM_DetallePoliticaJunction__c[] politicaIncentivoFechaVenta;
        TAM_SolicitudExpecionIncentivo__c[] solicitudExcepcion;
        User[] usr;
        Set<String> listaVINESet = new Set<String>();
        String searchKey = searchKeyWord + '%';
        String anioModelo;
        String codigoModelo;
        String VINMovimiento;
        Date fechaVenta;
        
        //Obtenemos el dealer correspondiente al usuario que esta haciendo uso del sistema
        if(userId != null){
            usr = [Select id,CodigoDistribuidor__c FROM User where id =:userId]; 
        }
        
        //Agregamos en una lista las VINES
        if(!listaVINES.isEmpty()){
            for(wrapperEstadoCta i : listaVINES){
                listaVINESet.add(i.VIN);
                
            }
            
        }
        
        //Query para consultar el objeto Vehiculo
        List<Vehiculo__c> vehicleObj = new List<Vehiculo__c> ();
        if(tipoEdoCta == 'Retail' || tipoEdoCta == 'Bono' || tipoEdoCta == 'AutoDemo' || tipoEdoCta == 'VentaCorporativa'){
            vehicleObj = [SELECT id,Ultimo_Movimiento__r.id,Ultimo_Movimiento__r.vin__r.name,Ultimo_Movimiento__r.Factura__c,Ultimo_Movimiento__r.Distribuidor__r.Codigo_Distribuidor__c,Vehiculo__c.Distribuidor__c,Ultimo_Movimiento__r.VIN__c,Ultimo_Movimiento__r.TAM_VIN__c,Ultimo_Movimiento__r.Submitted_Date__c,Ultimo_Movimiento__r.Trans_Type__c,Ultimo_Movimiento__r.Fleet__c,
                          Ultimo_Movimiento__r.Sale_Code__c,Ultimo_Movimiento__r.name,Ultimo_Movimiento__r.Sale_Date__c,Ultimo_Movimiento__r.TAM_Serie__c,
                          name,Ultimo_Movimiento__r.TAM_codigoModelo__c,Ultimo_Movimiento__r.TAM_AnioModelo__c from  Vehiculo__c
                          WHERE Ultimo_Movimiento__r.Distribuidor__r.Codigo_Distribuidor__c =: usr[0].CodigoDistribuidor__c  AND name LIKE: searchKey order by Ultimo_Movimiento__r.Submitted_Date__c desc limit 5 ];  
        
                          system.debug('ventas vindd'+vehicleObj);
        }
        
        //Se consultan los movimientos de RVRSL relacionados del VIN
        List<Movimiento__c> movVINES = [Select id,Submitted_Date__c,Trans_Type__c From Movimiento__C WHERE VIN__r.name LIKE : searchKey order by Submitted_Date__c,Trans_Type__c desc ];
        List<Movimiento__c> movReversas = new List<Movimiento__c>();
        if(!movVINES.isEmpty()){
            for(Movimiento__c mov : movVINES){
                if(mov.Trans_Type__c == 'RVRSL'){
                    movReversas.add(mov);
                }
            }

        }

        //Tiene RVRSL como tipo de movimiento
        if(vehicleObj.size() > 0 && tipoEdoCta == 'VentaCorporativa'){
            if(vehicleObj[0].Ultimo_Movimiento__r.Trans_Type__c == 'RVRSL'){
                String errorCodigoReversas = 'El último movimiento del VIN reportado en Dealer Daily es una RVRSL.';
                reglasNoCumplidasBonoRetail.add(errorCodigoReversas);
                
            }
        }
        
        // Se verifica que exista una política vigente de VC para la fecha de venta del VIN
        if(vehicleObj.size() > 0 && tipoEdoCta == 'VentaCorporativa'){
            anioModelo = vehicleObj[0].Ultimo_Movimiento__r.TAM_AnioModelo__c;
            codigoModelo =  vehicleObj[0].Ultimo_Movimiento__r.TAM_codigoModelo__c;
            VINMovimiento = vehicleObj[0].Ultimo_Movimiento__r.vin__r.name;
            fechaVenta = date.valueOf(vehicleObj[0].Ultimo_Movimiento__r.Submitted_Date__c);
        }
        
        if(tipoEdoCta == 'VentaCorporativa'){
            politicaIncentivoFechaVenta = [Select id from TAM_DetallePoliticaJunction__c WHERE TAM_PoliticaIncentivos__r.recordType.name = 'Venta Corporativa' AND (TAM_PoliticaIncentivos__r.TAM_EstatusIncentivos__c = 'Vigente' or TAM_PoliticaIncentivos__r.TAM_EstatusIncentivos__c = 'Vencida')
                                           AND (TAM_IncPropuesto_Cash__c != null OR TAM_IncPropuesto_Porcentaje__c != null) AND TAM_AnioModelo__c =: anioModelo AND TAM_Clave__c =: codigoModelo
                                           AND (TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c <=:  fechaVenta AND TAM_PoliticaIncentivos__r.TAM_FinVigencia__c >=: fechaVenta)
                                          ];
            
        }
        
        //Verificamos que exista por lo menos una política vigente
        if(tipoEdoCta == 'VentaCorporativa'){
            if(politicaIncentivoFechaVenta.size() == 0){
                String errorCodigoPoliticaInc = 'El VIN no cuenta con un incentivo vigente de fecha de venta';
                reglasNoCumplidasBonoRetail.add(errorCodigoPoliticaInc);
            }
        }
        
        // El tipo de venta es N  y no corresponde al proceso de VC
        if(vehicleObj.size() > 0 && tipoEdoCta == 'VentaCorporativa'){
            if(vehicleObj[0].Ultimo_Movimiento__r.Fleet__c == 'N'){
                String errorCodigoTipoVenta = 'VIN reportado en dealer daily como retail (es decir con código N).';
                reglasNoCumplidasBonoRetail.add(errorCodigoTipoVenta);
                
            } 
        }
        
        // VIN Reportado en Dealer Daily con factura Dummy
        if(vehicleObj.size() > 0 && tipoEdoCta == 'VentaCorporativa'){
            if(vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'DDDD'|| vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'DDDDD' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'DDDDDDDDD' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'DDDDDDDDDD' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'AUTO DEMO' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '0' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'A0000'
               || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'A000000000' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'AAGS' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FFFF'  || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FFFFF'  || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FFFFFF' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FFFFFFF' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FLT'
               || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FNC' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FNCT' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'S/F' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'VD' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '0' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '00' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '000'|| vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '0000'
               || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '00000'){
                   String errorFacturaDummy = 'Factura de venta no reportada en Dealer Daily.';
                   reglasNoCumplidasBonoRetail.add(errorFacturaDummy);
                   
               } 
        }
        
        //Se verifica que VIN tenga una solicitud de venta corporativa
        TAM_CheckOutDetalleSolicitudCompra__c[] solicitudVentaCorporativa;
        if(tipoEdoCta == 'VentaCorporativa'){
            system.debug('VIN VC CHECK'+VINMovimiento);
            solicitudVentaCorporativa = [Select id,name,TAM_EntregadoDealer__c,TAM_EstatusEntrega__c,TAM_EstatusDealerSolicitud__c
                                         From TAM_CheckOutDetalleSolicitudCompra__c WHERE TAM_VIN__c =: VINMovimiento order by TAM_SolicitudFlotillaPrograma__r.TAM_FechaCierreSolicitud__c desc limit 1];
        }
        system.debug('estatus sol deal'+solicitudVentaCorporativa);
        //Verificamos que el VIN tenga una solicitud de venta corporativa
        if(tipoEdoCta == 'VentaCorporativa'){
            if(solicitudVentaCorporativa.size() == 0){
                String errorCodigoVINSinSolicitudVC = 'El VIN no tiene una solicitud de venta corporativa.';
                reglasNoCumplidasBonoRetail.add(errorCodigoVINSinSolicitudVC);
            }
        }
        //Verificamos si el VIN tiene solicitudes de venta corporativas cancelada
        if(tipoEdoCta == 'VentaCorporativa'){
            if(!solicitudVentaCorporativa.isEmpty()){
                if(solicitudVentaCorporativa[0].TAM_EstatusDealerSolicitud__c == 'Pendiente'){
                    String errorCodigoSolicitudPendiente = 'La solicitud de Venta Corporativa se encuentra con estatus: Pendiente';
                    reglasNoCumplidasBonoRetail.add(errorCodigoSolicitudPendiente);
                }
            }
        }
        
        //Verificamos si el VIN tiene solicitudes de venta corporativas pendiente
        if(tipoEdoCta == 'VentaCorporativa'){
            if(!solicitudVentaCorporativa.isEmpty()){
                if(solicitudVentaCorporativa[0].TAM_EstatusDealerSolicitud__c == 'Cancelada'){
                    String errorCodigoSolicitudPendiente = 'La solicitud de Venta Corporativa se encuentra con estatus: Cancelada';
                    reglasNoCumplidasBonoRetail.add(errorCodigoSolicitudPendiente);
                }
            }
        }

        //Verificamos si el VIN tiene solicitudes de venta corporativas rechazada
        if(tipoEdoCta == 'VentaCorporativa'){
            if(!solicitudVentaCorporativa.isEmpty()){
                if(solicitudVentaCorporativa[0].TAM_EstatusDealerSolicitud__c == 'Rechazada'){
                    String errorCodigoSolicitudPendiente = 'La solicitud de Venta Corporativa se encuentra con estatus: Rechazada';
                    reglasNoCumplidasBonoRetail.add(errorCodigoSolicitudPendiente);
                }
            }
        }
        
        //Reporte de venta (RVRSL) meses atrás lo cual no cumple con políticas
        if(tipoEdoCta == 'VentaCorporativa'){
            if(!movReversas.isEmpty()){
                String rvrslMesesAnteriores = 'Reporte de venta (RVRSL) meses atrás lo cual no cumple con políticas';
                reglasNoCumplidasBonoRetail.add(rvrslMesesAnteriores);

            }

        }




        //REGLAS CORRESPONDIENTES A RETAIL - BONO
        //Tiene movimientos de tipo RVRSL
        if(vehicleObj.size() > 0 && (tipoEdoCta == 'Retail' || tipoEdoCta == 'Bono')){
            if(vehicleObj[0].Ultimo_Movimiento__r.Trans_Type__c == 'RVRSL'){
                String errorCodigoReversas = 'El último movimiento del VIN reportado en Dealer Daily es una RVRSL.';
                reglasNoCumplidasBonoRetail.add(errorCodigoReversas);
                
            }
        }
        //Código de venta corresponde a un auto demo aplica para retail,vc y bonos
        if(vehicleObj.size() > 0){
            if(vehicleObj[0].Ultimo_Movimiento__r.Sale_Code__c == '06' && tipoEdoCta != 'AutoDemo'){
                String errorCodigo06 = 'VIN reportado con código 06 utilizado para reportar autos demo.';
                reglasNoCumplidasBonoRetail.add(errorCodigo06);
                
            } 
        }
        // El tipo de venta es C y no corresponde al proceso de retail
        if(vehicleObj.size() > 0 && (tipoEdoCta == 'Retail' || tipoEdoCta == 'Bono')){
            if(vehicleObj[0].Ultimo_Movimiento__r.Fleet__c == 'C'){
                String errorCodigoTipoVenta = ' VIN reportado en dealer daily como flotilla (es decir con código C).';
                reglasNoCumplidasBonoRetail.add(errorCodigoTipoVenta);
                
            } 
        }
        // VIN Reportado en Dealer Daily con factura Dummy
        if(vehicleObj.size() > 0 && (tipoEdoCta == 'Retail' || tipoEdoCta == 'Bono')){
            if(vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'DDDD'|| vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'DDDDD' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'DDDDDDDDD' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'DDDDDDDDDD' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'AUTO DEMO' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '0' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'A0000'
               || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'A000000000' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'AAGS' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FFFF'  || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FFFFF'  || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FFFFFF' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FFFFFFF' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FLT'
               || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FNC' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'FNCT' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'S/F' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == 'VD' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '0' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '00' || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '000'|| vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '0000'
               || vehicleObj[0].Ultimo_Movimiento__r.Factura__c == '00000'){
                   String errorFacturaDummy = 'Factura de venta no reportada en Dealer Daily.';
                   reglasNoCumplidasBonoRetail.add(errorFacturaDummy);
                   
               } 
        }
        
        // Se verifica que exista una política vigente de Retail para la fecha de venta del VIN
        if(vehicleObj.size() > 0){
            anioModelo = vehicleObj[0].Ultimo_Movimiento__r.TAM_AnioModelo__c;
            codigoModelo =  vehicleObj[0].Ultimo_Movimiento__r.TAM_codigoModelo__c;
            VINMovimiento = vehicleObj[0].Ultimo_Movimiento__r.vin__r.name;
            fechaVenta = date.valueOf(vehicleObj[0].Ultimo_Movimiento__r.Submitted_Date__c);
        }
        
        if(tipoEdoCta == 'Retail'){
            politicaIncentivoFechaVenta = [Select id from TAM_DetallePoliticaJunction__c WHERE TAM_PoliticaIncentivos__r.recordType.name = 'Retail' AND (TAM_PoliticaIncentivos__r.TAM_EstatusIncentivos__c = 'Vigente' or TAM_PoliticaIncentivos__r.TAM_EstatusIncentivos__c = 'Vencida')
                                           AND TAM_IncPropuesto_Cash__c != null AND TAM_AnioModelo__c =: anioModelo AND TAM_Clave__c =: codigoModelo
                                           AND (TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c <=:  fechaVenta AND TAM_PoliticaIncentivos__r.TAM_FinVigencia__c >=: fechaVenta)
                                          ];
        }
        //Verificamos que exista por lo menos una política vigente
        if(tipoEdoCta == 'Retail'){
            if(politicaIncentivoFechaVenta.size() == 0){
                String errorCodigoPoliticaInc = 'El VIN no cuenta con un incentivo vigente de fecha de venta.';
                reglasNoCumplidasBonoRetail.add(errorCodigoPoliticaInc);
            }
        }

        //Verificamos que la fecha de termino de política no excede los 90 días al día de hoy
        if(tipoEdoCta == 'Retail' || tipoEdoCta == 'VentaCorporativa' || tipoEdoCta == 'AutoDemo' || tipoEdoCta == 'Bono'){
            if(politicaIncentivoFechaVenta.size() > 0){
                Integer diasDeTermino = (Date.valueOf(politicaIncentivoFechaVenta[0].TAM_PoliticaIncentivos__r.TAM_FinVigencia__c )).daysBetween(System.today());
                if(diasDeTermino >= 90){
                    String errorCodigoPoliticaInc = 'Política de incentivo vencida (Excedió los 90 días para su cobro).';
                    reglasNoCumplidasBonoRetail.add(errorCodigoPoliticaInc);
                }
            }
        }
 
        //Retail EL VIN cerro con RDR en periodos anteriores y cuenta con uno o mas moviemientos posteriores de RVRSL
        //Se el VIN fue vendido en otro periodo pero registra movimientos de REVERSA posteriores
        if(!movReversas.isEmpty()){
            if(tipoEdoCta == 'Retail'){
                String errorCodigoPoliticaInc = 'El VIN cerró con RDR en periodos anteriores (vendido) y cuenta con uno o más movimientos de reversa posteriores a ese periodo de ventas en le que cerró como vendido.';
                reglasNoCumplidasBonoRetail.add(errorCodigoPoliticaInc);

            }

        }

        
        //Si se agrega un VIN desde la sección de Bono
        TAM_DetalleBonos__c[] bonosDisponibles;
        if(tipoEdoCta == 'Bono'){
            bonosDisponibles = [Select id,TAM_AnioModelo__c,Bono__c,TAM_Clave__c,TAM_Serie__c 
                                From TAM_DetalleBonos__c WHERE (Bono__r.TAM_InicioVigencia__c <=: fechaVenta AND Bono__r.TAM_FinVigencia__c >=: fechaVenta) AND
                                TAM_AnioModelo__c =: anioModelo AND TAM_Clave__c =: codigoModelo AND TAM_BonoTotalEfectivo__c != null 
                               ];
            
            
        }
        
        //Verificamos que exista por lo menos una política vigente de bono de acuerdo con el modelo
        if(tipoEdoCta == 'Bono'){
            if(bonosDisponibles.size() == 0){
                String errorCodigoBono= 'El VIN no cuenta con un Bono de fecha de venta.';
                reglasNoCumplidasBonoRetail.add(errorCodigoBono);
            }
        }
        
        //Se verifica que el VIN tenga solicitudes de pago de Bono dadas de alta
        TAM_SolicitudDeBono__c[] solicitudBono;
        if(tipoEdoCta == 'Bono'){
            solicitudBono = [Select id,TAM_AprobacionFinanzas__c From TAM_SolicitudDeBono__c WHERE TAM_VIN__c =: VINMovimiento order by createdDate asc limit 1];
            
            
        }
        
        //Verificamos si existen solicitudes de bono
        if(tipoEdoCta == 'Bono'){
            if(solicitudBono.size()	 <=  0){
                String errorCodigoSolicitudBono= 'El VIN no cuenta con solicitudes de pago (Bono) en Salesforce.';
                reglasNoCumplidasBonoRetail.add(errorCodigoSolicitudBono);
            }
        }
        //Verificamos si existen solicitudes de bono y si existen verificamos el estatus de la solicitud
        if(tipoEdoCta == 'Bono'){
            if(solicitudBono.size()	> 0 && (solicitudBono[0].TAM_AprobacionFinanzas__c == 'Pendiente' || solicitudBono[0].TAM_AprobacionFinanzas__c == 'Rechazado')){
                String errorCodigoSolicitudBono= 'La solicitud de Bono se encuentra en estatus :'+solicitudBono[0].TAM_AprobacionFinanzas__c;
                reglasNoCumplidasBonoRetail.add(errorCodigoSolicitudBono);
            }
        }
        //AUTOS DEMO se verifica que existan solicitudes de auto demo dadas de alta 
        TAM_SolicitudAutoDemo__c[] solicitudAutoDemo;
        if(tipoEdoCta == 'AutoDemo'){
            solicitudAutoDemo = [Select id From TAM_SolicitudAutoDemo__c WHERE TAM_VIN__c =: VINMovimiento];
            
        }
        //El VIN no tiene una solicitud de auto demo en salesforce
         if(tipoEdoCta == 'AutoDemo'){
        if(vehicleObj.size() > 0 && solicitudAutoDemo.isempty()){
       
                String errorCodigoSolicitudBono= 'El VIN no cuenta con solicitud de cobro (Auto Demo) en Salesforce.';
                reglasNoCumplidasBonoRetail.add(errorCodigoSolicitudBono);
                
            }
            
        }
        //Codigo de venta diferente a 06 
        if(vehicleObj.size() > 0){
        if(tipoEdoCta == 'AutoDemo' && vehicleObj[0].Ultimo_Movimiento__r.Sale_Code__c != '06'){
                String errorCodigoSolicitudBono= 'El VIN se reporto con un código diferente a 06 utilizado para reportar autos demo.';
                reglasNoCumplidasBonoRetail.add(errorCodigoSolicitudBono);
                
            }
            
        }
        //El VIN tiene como ultimo moviemiento la RVRSL
        if(vehicleObj.size() > 0 &&  tipoEdoCta == 'AutoDemo'){
            if(vehicleObj[0].Ultimo_Movimiento__r.Trans_Type__c == 'RVRSL'){
                String errorCodigoReversas = 'El último movimiento del VIN reportado en Dealer Daily es una RVRSL.';
                reglasNoCumplidasBonoRetail.add(errorCodigoReversas);
                
            }
        }
        //Fleet C
        if(vehicleObj.size() > 0 &&  tipoEdoCta == 'AutoDemo'){
            if(vehicleObj[0].Ultimo_Movimiento__r.Fleet__c == 'C'){
                String errorCodigoTipoVenta = ' VIN reportado en dealer daily como flotilla (es decir con código C).';
                reglasNoCumplidasBonoRetail.add(errorCodigoTipoVenta);
            }
        }
        
        //Si el proceso corresponde a bonos o retail
        if(!vehicleObj.isEmpty()){
            for (Vehiculo__c  VINPagado : vehicleObj) {	 
                wrapVIN newVIN = new wrapVIN();
                newVIN.Id = VINPagado.Ultimo_Movimiento__r.Id;
                newVIN.reglasNoCumplidas = reglasNoCumplidasBonoRetail;
                newVIN.VIN = VINPagado.Ultimo_Movimiento__r.TAM_VIN__c;
                newVIN.ubicacionVIN = 'dealerDaily';
                //Serie
                newVIN.Serie = VINPagado.Ultimo_Movimiento__r.TAM_Serie__c ;                
                //codigo Modelo
                newVIN.codigoModelo = VINPagado.Ultimo_Movimiento__r.TAM_codigoModelo__c ;
                //Anio Modelo
                newVIN.anioModelo = VINPagado.Ultimo_Movimiento__r.TAM_AnioModelo__c ;
                //Código Dealer
                newVIN.codigoDealer = VINPagado.Ultimo_Movimiento__r.Distribuidor__r.Codigo_Distribuidor__c ;
                wrapListVIN.add(newVIN);   
                
            }
        }
        
        
        return wrapListVIN;        
    }
    
    @AuraEnabled
    public static List <wrapperMovimiento > vinDealerDaily(String searchKeyWord,String userId, Boolean isAutoDemo) {
        User[] usr;
        List <Movimiento__C > returnList = new List <Movimiento__C > ();
        List <Movimiento__C > lstOfVin = new List <Movimiento__C > ();
        Date fechaHoy = system.today();
        Date fechaMenos2Meses = date.today().adddays(-365);
        String searchKey = searchKeyWord + '%';
        
        usr = [Select id,CodigoDistribuidor__c FROM User where id =:userId];     
        
        if(isAutoDemo == false){
            lstOfVin = [SELECT id,Sale_Code__c,VIN__r.Ultimo_Movimiento__r.Fleet__c,VIN__r.Ultimo_Movimiento__r.Trans_Type__c,Submitted_Date__c,Distribuidor__c,VIN__r.name,Sale_Date__c,TAM_Serie__c,TAM_VIN__c,TAM_codigoModelo__c,TAM_AnioModelo__c from  Movimiento__C
                        WHERE 
                        Distribuidor__r.Codigo_Distribuidor__c =: usr[0].CodigoDistribuidor__c AND Submitted_Date__c >=: fechaMenos2Meses AND Submitted_Date__c <=: fechaHoy AND  VIN__r.name LIKE: searchKey  AND Trans_Type__c = 'RDR' 
                        order by VIN__r.Ultimo_Movimiento__r.Submitted_Date__c asc];
        }
        
        if(isAutoDemo == true){
            lstOfVin = [SELECT id,Sale_Code__c,Submitted_Date__c,VIN__r.Ultimo_Movimiento__r.Fleet__c,VIN__r.Ultimo_Movimiento__r.Trans_Type__c,Distribuidor__c,VIN__r.name,Sale_Date__c,TAM_Serie__c,TAM_VIN__c,TAM_codigoModelo__c,TAM_AnioModelo__c from  Movimiento__C
                        WHERE 
                        Submitted_Date__c >=: fechaMenos2Meses AND Submitted_Date__c <=: fechaHoy AND  VIN__r.name LIKE: searchKey  AND Trans_Type__c = 'RDR' AND Distribuidor__R.Codigo_Distribuidor__c =: usr[0].CodigoDistribuidor__c AND Sale_Code__c = '06'
                        order by VIN__r.Ultimo_Movimiento__r.Submitted_Date__c asc];
        }
        
        
        //Se toman los vines en unas lista
        Set<String> listVINES = new Set<String>();
        
        //Se recorre la lista de VINES
        for(Movimiento__c movReg : lstOfVin){
            listVINES.add(movReg.VIN__r.name);
            
        }
        
        
        //Se crea un mapa de VIN x Movimientos
        Map<String,Movimiento__c[]> listMovByVIN = new Map<String,Movimiento__c[]>();
        
        for(Movimiento__c movReg : lstOfVin){
            if(!listMovByVIN.containsKey(movReg.VIN__r.name)){    
                listMovByVIN.put(movReg.VIN__r.name, new Movimiento__c[]{});
            }
            listMovByVIN.get(movReg.VIN__r.name).add(movReg);
            
        }
        
        //Se crea a la lista de moviemientos que retornara el metodo
        List<Movimiento__c> listMovFiltrada = new List<Movimiento__c>();
        for(String VIN : listVINES){
            if(listMovByVIN.containsKey(VIN)){
                List<Movimiento__c> movimientoByMap = listMovByVIN.get(VIN);
                listMovFiltrada.add(movimientoByMap[0]);
                
            }
            
        }
        
        List<wrapperMovimiento> listWrapperMovimiento = new List<wrapperMovimiento>();
        if(!listMovFiltrada.isEmpty()){
            Date fechaReporte = listMovFiltrada[0].Submitted_Date__c.date();
            List<TAM_CalendarioToyota__c> periodoVentas = [SELECT Id,name,TAM_FechaInicio__c,TAM_FechaFin__c FROM TAM_CalendarioToyota__c 
                                                            where (TAM_FechaInicio__c <=: fechaReporte and TAM_FechaFin__c >=: fechaReporte) order by TAM_FechaFin__c limit 1];


            for (Movimiento__C  acc: listMovFiltrada) {
                wrapperMovimiento wrapperItem = new wrapperMovimiento();
                wrapperItem.Id = acc.Id; 
                wrapperItem.Submitted_Date = acc.Submitted_Date__c;           
                Integer rangoDias  = (system.today()).daysBetween(Date.valueOf(periodoVentas[0].TAM_FechaFin__c));
                List<String> mensajesValidacion = new List<String>();
                //No Cumple con el plazo de días
                wrapperItem.diasDeReportes  = rangoDias;
                if(rangoDias <= -95){
                    String mensajeValidacion1 = label.TAM_ExcepcionRetail1;
                    mensajesValidacion.add(mensajeValidacion1);
                    wrapperItem.mensajeValidacion = mensajesValidacion; 
                    wrapperItem.cumpleValidacion  = false;
                    
                }
                
                //No cumple con RDR en dealer daily como último movimiento
                if(acc.VIN__r.Ultimo_Movimiento__r.Trans_Type__c != 'RDR'){
                    String mensajeValidacion2 = label.TAM_ExcepcionRetail2;
                    mensajesValidacion.add(mensajeValidacion2);
                    wrapperItem.mensajeValidacion = mensajesValidacion; 
                    wrapperItem.cumpleValidacion  = false;
                    
                }
                
                //VIN con tipo de reporte de flotilla 
                if(acc.VIN__r.Ultimo_Movimiento__r.Fleet__c == 'C'){
                    String mensajeValidacion3 = label.TAM_ExcepcionRetail3;
                    mensajesValidacion.add(mensajeValidacion3);
                    wrapperItem.mensajeValidacion = mensajesValidacion; 
                    wrapperItem.cumpleValidacion  = false;
                    
                }
                
                //VIN de tipo retail pero reportado como AutoDemo
                if(isAutoDemo == false && acc.Sale_Code__c == '06'){
                    String mensajeValidacion4 = label.TAM_ExcepcionRetail4; 
                    mensajesValidacion.add(mensajeValidacion4);
                    wrapperItem.mensajeValidacion = mensajesValidacion; 
                    wrapperItem.cumpleValidacion  = false;
                    
                }
                
                //cumple con las condiciónes Retail
                if(rangoDias > -95 && acc.VIN__r.Ultimo_Movimiento__r.Trans_Type__c == 'RDR' && acc.VIN__r.Ultimo_Movimiento__r.Fleet__c == 'N'
                   && acc.Sale_Code__c != '06' && isAutoDemo == false){
                       String mensajeValidacion3 = 'Cumple con las condiciónes'; 
                       mensajesValidacion.add(mensajeValidacion3);
                       wrapperItem.mensajeValidacion = mensajesValidacion; 
                       wrapperItem.cumpleValidacion  = true;
                       
                   }
                
                //cumple con las condiciónes AutoDemo
                if(rangoDias > -95 && acc.VIN__r.Ultimo_Movimiento__r.Trans_Type__c == 'RDR' && acc.VIN__r.Ultimo_Movimiento__r.Fleet__c == 'N'
                   && acc.Sale_Code__c == '06' && isAutoDemo == true){
                       String mensajeValidacion3 = 'Cumple con las condiciónes'; 
                       mensajesValidacion.add(mensajeValidacion3);
                       wrapperItem.mensajeValidacion = mensajesValidacion; 
                       wrapperItem.cumpleValidacion  = true;
                       
                   }
                
                wrapperItem.Distribuidor = acc.Distribuidor__c ;
                wrapperItem.VIN_name = acc.VIN__r.name ;
                wrapperItem.Sale_Date =    acc.Submitted_Date__c ;
                wrapperItem.TAM_Serie  =   acc.TAM_Serie__c ;
                wrapperItem.TAM_VIN = acc.TAM_VIN__c;
                wrapperItem.TAM_codigoModelo = acc.TAM_codigoModelo__c;
                wrapperItem.TAM_AnioModelo = acc.TAM_AnioModelo__c;
                listWrapperMovimiento.add(wrapperItem);
                
            }
        }
        
        system.debug('return'+listWrapperMovimiento);    
        return  listWrapperMovimiento;     
        
        
    }
    
    @AuraEnabled
    public static List <wrapVIN > vinBDDVentas(String searchKeyWord,String userId) {
        User[] usr;
        List<wrapVIN> wrapListVIN = new List<wrapVIN>();
        List <InventarioWholesale__c> lstOfVin = new List <InventarioWholesale__c>();
        Date fechaHoy = system.today();
        Date fechaMenos2Meses = date.today().adddays(-100);
        String searchKey = searchKeyWord + '%';
        
        usr = [Select id,CodigoDistribuidor__c FROM User where id =:userId];   
        
        lstOfVin = [SELECT AnioFactura__c,ConnectionReceivedId,ConnectionSentId,CreatedById,
                    CreatedDate,Dealer_Code__c,Diadefactura__c,Distributor_Invoice_Date_MM_DD_YYYY__c,
                    Exterior_Color_Code__c,Exterior_Color_Description__c,FechaFactura__c,Id,
                    Interior_Color_Code__c,Interior_Color_Description__c,IsDeleted,LastModifiedById,
                    LastModifiedDate,LastReferencedDate,LastViewedDate,MesFactura__c,Model_Number__c,
                    Model_Year__c,Name,OwnerId,SystemModstamp,TAM_ExteriorColorCode__c,TAM_IdExterno__c,
                    TAM_InteriorColorCode__c,Toms_Series_Name__c
                    FROM InventarioWholesale__c WHERE Name LIKE: searchKey AND  Dealer_Code__c =: usr[0].CodigoDistribuidor__c ];
        
        
        if(!lstOfVin.isEmpty()){
            for (InventarioWholesale__c  acc: lstOfVin) {	
                wrapVIN newVIN = new wrapVIN();
                newVIN.VIN = acc.name;
                newVIN.inventarioG = true;
                newVIN.inventarioF = false;
                newVIN.Serie = acc.Toms_Series_Name__c;
                newVIN.codigoModelo = acc.Model_Number__c;
                newVIN.anioModelo = acc.Model_Year__c;
                newVIN.codigoDealer = acc.Dealer_Code__c;
                wrapListVIN.add(newVIN);   
                
            }
        }
        
        if(!wrapListVIN.isEmpty()){
            return wrapListVIN; 
        }else{
            wrapListVIN = lookUpController.vinInventarioF(searchKeyWord,userId);
            return wrapListVIN;
        }
        
        
    }
    
    @AuraEnabled
    public static List <wrapVIN > vinInventarioF(String searchKeyWord,String userId) {
        User[] usr;
        List<wrapVIN> listWrapVIN = new List<wrapVIN>();
        List<Inventario_en_Transito__c> listaInventarioF = new  List<Inventario_en_Transito__c>  ();
        String searchKey = searchKeyWord + '%';
        
        usr = [Select id,CodigoDistribuidor__c FROM User where id =:userId];  
        
        listaInventarioF = [SELECT id,Name,Dealer_Code__c,Toms_Series_Name__c,Model_Number__c,Model_Year__c FROM Inventario_en_Transito__c WHERE Name LIKE:  searchKey AND Dealer_Code__c =: usr[0].CodigoDistribuidor__c];
        
        if(!listaInventarioF.isEmpty()){
            for(Inventario_en_Transito__c invenF : listaInventarioF){
                wrapVIN newInventario = new wrapVIN();
                newInventario.VIN = invenF.Name;
                newInventario.inventarioG = false;
                newInventario.inventarioF = true;
                newInventario.Serie = invenF.Toms_Series_Name__c;
                newInventario.codigoModelo = invenF.Model_Number__c;
                newInventario.anioModelo = invenF.Model_Year__c;
                newInventario.codigoDealer = invenF.Dealer_Code__c;
                listWrapVIN.add(newInventario);
            }
        }
        
        return listWrapVIN;
    }
    
    
    public class wrapVIN {
        @AuraEnabled public boolean inventarioG {get; set;}
        @AuraEnabled public boolean inventarioF {get; set;}
        @AuraEnabled public List<String> reglasNoCumplidas {get; set;} 
        @AuraEnabled public String codigoDealer {get; set;} 
        @AuraEnabled public String VIN {get; set;} 
        @AuraEnabled public String Serie {get; set;}
        @AuraEnabled public String codigoModelo {get; set;}
        @AuraEnabled public String anioModelo {get; set;}
        @AuraEnabled public String Id {get; set;}
        @AuraEnabled public String ubicacionVIN {get; set;}
        @AuraEnabled public Boolean vinDealerDaily {get; set;}
        @AuraEnabled public Boolean vinInventarioF {get; set;}
        @AuraEnabled public decimal precioPublicoVigente {get; set;} 
        @AuraEnabled public decimal precioPublicoDeVenta {get; set;}
        @AuraEnabled public decimal incentivoPagado {get; set;}
        @AuraEnabled public Date fechaVentaVIN {get; set;}
        @AuraEnabled public String folioFactura {get; set;}
        @AuraEnabled public Date fechaFactura {get; set;}
        
        
    }
    
    public class wrapperEstadoCta {
        @AuraEnabled public String Id {get; set;}
        @AuraEnabled public String nombrePropietario {get; set;}
        @AuraEnabled public String apellidoPropietario {get; set;}
        @AuraEnabled public String IdDetalleProvision {get; set;}
        @AuraEnabled public String IdDetalleEdoCta {get; set;}
        @AuraEnabled public String IdEstadoCuenta {get; set;}
        @AuraEnabled public String VIN {get; set;}
        @AuraEnabled public String serie {get; set;}
        @AuraEnabled public String codigoModelo {get; set;}
        @AuraEnabled public String anioModelo {get; set;}
        @AuraEnabled public decimal incentivoProvisionadoDealer {get; set;}
        @AuraEnabled public decimal incentivoSolicitadoDealer {get; set;}
        @AuraEnabled public String nombreProvision {get; set;}
        @AuraEnabled public String idProvision {get; set;}
        @AuraEnabled public String codigoDealer {get; set;}
        @AuraEnabled public String nombreDealer {get; set;}        
        @AuraEnabled public String facturaVenta {get; set;}
        @AuraEnabled public String IdfacturaVenta {get; set;}
        @AuraEnabled public String comentarioDealer {get; set;}
        @AuraEnabled public Boolean VINEntregado {get; set;} 
        @AuraEnabled public Boolean EdoCtaCerrado {get; set;} 
        @AuraEnabled public String estatusVINEdoCta {get; set;}
    }
    
    public class wrapperMovimiento { 
        @AuraEnabled public String Id {get; set;}
        @AuraEnabled public DateTime Submitted_Date {get; set;}
        @AuraEnabled public String Distribuidor {get; set;}
        @AuraEnabled public String VIN_name {get; set;} 
        @AuraEnabled public DateTime Sale_Date {get; set;}
        @AuraEnabled public String TAM_Serie {get; set;}
        @AuraEnabled public String TAM_VIN {get; set;}
        @AuraEnabled public String TAM_codigoModelo {get; set;}
        @AuraEnabled public String TAM_AnioModelo {get; set;}
        @AuraEnabled public List<String> mensajeValidacion {get; set;}
        @AuraEnabled public Boolean cumpleValidacion {get; set;} 
        @AuraEnabled public Integer diasDeReportes {get; set;} 
        
        
    }
    
}